/* @(#)rsort.c	2.1 88/08/11 4.0 RPCSRC */
/*
 * rsort.c
 * Client side application which sorts argc, argv.
 */
#include <stdio.h>
#include <rpc/rpc.h>
#include <rpc/mrpc.h>
#include "sort.h"

main(int argc, char** argv) {
  CLIENT *cl;
  char *server;
  struct sortstrings args;
  struct sortstrings* res;
  int i;

  if (argc < 3) {
    fprintf(stderr, "usage: %s host [s1 ...]\n", argv[0]);
    exit(1);
  }

  mtcp_init();
  
  server = argv[1];
  /*
   * Create client "handle" used for calling DIRPROG on the
   * server designated on the command line. We tell the rpc package
   * to use the "tcp" protocol when contacting the server.
   */
  cl = mrpc_clnt_create(server, SORTPROG, SORTVERS, "rmp");
  if (cl == NULL) {
    /*
     * Couldn't establish connection with server.
     * Print error message and die.
     */
    clnt_pcreateerror(server);
    exit(1);
  }
  
  args.ss.ss_len = argc - 2;	/* substract off progname, machinename */
  args.ss.ss_val = &argv[2];

  printf("BEFORE SORT CALL.\n");

  res = sort_1(&args, cl);

  printf("AFTER SORT CALL.\n");

  if (res == NULL) {
    /*
     * An error occurred while calling the server. 
     * Print error message and die.
     */
    clnt_perror(cl, server);
    exit(1);
  }
  
  for (i = 0; i < res->ss.ss_len; i++) {
    printf("%s\n", res->ss.ss_val[i]);
  }

  /* should free res here */
  exit(0);
}
