#include <stdio.h>
#include <rpc/mrpc.h>
#include "sort.h"

static void sortprog_1();

main()
{
	SVCXPRT *transp;

        mtcp_init();

	(void)pmap_unset(SORTPROG, SORTVERS);

	transp = svcrmp_create("sort", RPC_ANYSOCK, 0, 0);
	if (transp == NULL) {
		(void)fprintf(stderr, "cannot create rmp service.\n");
		exit(1);
	}
	if (!svc_register(transp, SORTPROG, SORTVERS, sortprog_1, 0)) {
		(void)fprintf(stderr, "unable to register (SORTPROG, SORTVERS, tcp).\n");
		exit(1);
	}
	svc_run();
	(void)fprintf(stderr, "svc_run returned\n");
	exit(1);
}

static void
sortprog_1(rqstp, transp)
	struct svc_req *rqstp;
	SVCXPRT *transp;
{
	union {
		sortstrings sort_1_arg;
	} argument;
	char *result;
	bool_t (*xdr_argument)(), (*xdr_result)();
	char *(*local)();

	switch (rqstp->rq_proc) {
	case NULLPROC:
		(void)svc_sendreply(transp, xdr_void, (char *)NULL);
		return;

	case SORT:
		xdr_argument = xdr_sortstrings;
		xdr_result = xdr_sortstrings;
		local = (char *(*)()) sort_1;
		break;

	default:
		svcerr_noproc(transp);
		return;
	}
	bzero((char *)&argument, sizeof(argument));
	if (!svc_getargs(transp, xdr_argument, &argument)) {
		svcerr_decode(transp);
		return;
	}
	result = (*local)(&argument, rqstp);
	if (result != NULL && !svc_sendreply(transp, xdr_result, result)) {
		svcerr_systemerr(transp);
	}
	if (!svc_freeargs(transp, xdr_argument, &argument)) {
		(void)fprintf(stderr, "unable to free arguments\n");
		exit(1);
	}
}

